<?php
/*
Plugin Name: Mail supervisor
Version: 1.0.1
Description:  Mail supervisor surveille l'envoie des mails. 
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=315
Author: cljosse
Author URI:http://cljosse.e3b.org
*/


if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
define('mail_superv_DIR' , basename(dirname(__FILE__)));
define('MAIL_SUPERV_PATH' , PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)).'/');
include_once (MAIL_SUPERV_PATH.'include/constants.php'); 
include_once (MAIL_SUPERV_PATH.'include/fonctions.php'); 

/*
EVENT_HANDLER_PRIORITY_NEUTRAL  */

add_event_handler('send_mail', 'clj_mail',EVENT_HANDLER_PRIORITY_NEUTRAL - 1 , 6);

function clj_mail($result, $mailto, $subject, $content, $headers, $args)
{
    global $conf, $user, $lang_info,  $conf_mail,$mails_options,$mails_donnes , $template,$page ,$erreur_message; 
	// lecture config table -------------


	$mails_options = explode("," , $conf['mail_superv']);
	
	// lecture donnes       -------------
    $mails_donnes = Get_Datas();
	
	$nb_mails	  =	$mails_donnes['nb_mails'] ;
	$next_day  =  $mails_donnes['date_mail'] ;
	
	$reste =    $mails_donnes['reste'] ;
	$reste_mail =    $mails_donnes['reste_mail'] ;
	$reste_spam =    $mails_donnes['reste_spam'] ;
	
 $mails_donnes['quarantaine'] =    ( $mails_donnes['reste'] >0 ) ? "true" : "false" ;
 

    $match=array("<",">");
    $string=array("&lt;","&gt;") ;
	$search=array("D","H","M","S","W");
	$replace=array(" day"," Hour"," minute"," second"," week");
	
$header_message='<pre>
Destinataire :'.$mailto.'
Headers      :
'.str_replace( $match,$string, $headers).'
Sujet        :'.$subject.'
</pre>'; 

  $nb_destinataires=0;
 if ($mailto<>"" )  $nb_destinataires +=1; 
   //================= rcriture de l'entte ===============================

if ($mails_options[0] == 'on') {
 	if ($mailto=="")	$mailto=$conf_mail['email_webmaster'];
}
if ($mails_options[1] == 'on') { 
   		if (!empty($args['Cc']))
  		{
		  $nb_destinataires += count($args['Cc']);
		  $headers= corrige_header('Cc:',$headers);
  		}
  		if (!empty($args['Bcc']))
  		{
		  $nb_destinataires += count($args['Bcc']);
		  $headers	= corrige_header('Bcc',$headers);
		}

  }

if ($mails_options[2]=='on')   {

        $texte = "This is a multi-part message in MIME format.\n"; 
	
     	$texte .= "-----=".$conf_mail['boundary_key']."\n"; 
      	$texte .= "Ceci est un message est au format MIME.\n"; 
       	$texte .= 'Content-Type: text/plain; charset="UTF-8"'."\n"; 
       	$texte .= 'Content-Transfer-Encoding: 8bit'."\n\n";  
       	$texte .= $mails_donnes['header_text']; // A voir texte brut...
	   
	   	$texte .= "\n\n"; 
	
	  	$content =$texte .$content ;
}

	
$ret=false;
 if (    ($mails_donnes['quarantaine']=="false") ) 
  {
 	//======== Non mise en quarantaine =============

   		ob_start();
   	  		$ret = mail($mailto, 'Plugin'.$subject, $content, $headers);
 	  		$message = ob_get_contents();
    	ob_end_clean();
		
			$mails_donnes['message']=$message;	
			$est_un_spam =!(strpos(strtolower($message), 'spam') === false);
     		if ($est_un_spam == false) {
	           //--- Non dtection de spam ------------------
    			 if ($mails_donnes['nb_mails']==0) {
	       			$date_mail=time();
					
					$mails_periode="+".str_replace( $search, $replace, $mails_donnes['nb_mails_periode']);
					$next_day =  strtotime($mails_periode,time());
           			$mails_donnes['date_mail'] =  $next_day;
	 			} 	
	 			$next_day = time() + (0); 
 				$mails_donnes['date_quarantaine'] = $next_day ;
 	    		$mails_donnes['nb_mails'] += $nb_destinataires;
	  // teste limite atteinte :
	
	  if (($mails_donnes['nb_mails'] >= $mails_donnes['nb_mails_maxi'])) 
			{
			$erreur_message .= "ALERTE !!! DANGER DE MISE EN QUARANTAINE PAR VOTRE FAI <br />" ;
			$erreur_message .=  "Vous avez d&eacute;pass&eacute; le nombre de mails admissibles par semaine. <br /> <br />";
			$erreur_message .='Date du premier mail: ' . date('d-M-Y H:m:s',$mails_donnes['date_mail']);
			$rest_mail=  $mails_donnes['date_mail']-time() ; 
			$erreur_message .= '<br />Encore : '. int_to_heure($rest_mail) ;
			
				if ( (float) $rest_mail <= 0)
					{
					$mails_periode="+".str_replace( $search, $replace, $mails_donnes['nb_mails_periode']);
					$next_day =  strtotime($mails_periode,time());
           			$mails_donnes['date_mail'] =  $next_day;
				
					}
			
			
			}
			if ($ret==false) { 	
       			//=============== La fonction mail  retourne false=========================		
				$erreur_message .= '<br />---- La fonction mail &agrave; retourn&eacute;e [false]  ------<br />';
					$erreur_message .='-------- MESSAGE erreur : -------------<br />';
					$erreur_message .=$message ;				// Bad recipient address syntax 
 				$pos1 = strpos(strtolower($message), 'bad recipient address syntax');
				if (  !($pos1 === false) ){
				$erreur_message .='D&eacute;tection de : Bad recipient address syntax .';
 					$erreur_message .='V&eacuterifiez les destinataires: (Bcc,Cc,To)<br />';
 					}
					$erreur_message .='mailto:   "'.$mailto.'"<br />';

					$erreur_message .='--------HEADERS -----------------<br />
					';
					$erreur_message .=$headers ;
					

				}
			
 		}else{
		//--- Dtection de spam ------------------
 			
			if ($mails_donnes['nb_spams']==0) {  $mails_donnes['date_spam']= time(); 	}
			$mails_donnes['nb_spams'] += $nb_destinataires;
			
			$est_un_spam =!(strpos(strtolower($message), 'trop de spam') === false);
			
			if ( $est_un_spam ) { 
			    $mails_donnes['quarantaine']=true;
				 $spams_periode="+".str_replace($search, $replace, $mails_donnes['nb_spams_periode']);
				
					$next_day =  strtotime(  $spams_periode);
					
			//	$next_day =  strtotime('+2 day');
		 		$mails_donnes['date_quarantaine']= $next_day       ;			
			}
			else
			{
	 		$mails_donnes['quarantaine']= ($mails_donnes['nb_spams'] >= $mails_donnes['nb_spams_maxi']);
       		}
        	//	$next_day = time() + (2 * 24 * 60 * 60);
			if ($mails_donnes['quarantaine']) 
				{
				$erreur_message .= "ALERTE !!! DANGER DE MISE EN QUARANTAINE  <br />" ;
				$erreur_message .=  "Vous avez d&eacute;pass&eacute; le nombre de spmas admissibles. <br /> <br />";
				}
	    		$erreur_message .="<br> Detection $message <br />".
				"Nombre de spams d&eacute;tect&eacutes; ".$mails_donnes['nb_spams'];
 			}
 
  	}else{
		//======== Mise en quarantaine       =============
$erreur_message =  '<br />
Nous sommes le :       '. date('d-M-Y H:m:s') ."<br />";

		if 	($reste >= 0) {
$erreur_message .=
"MISE EN QUARANTAINE !"."<br />".
"Nombre de spams envoy&eacute;s :". $mails_donnes['nb_spams']."<br />".
"Depuis le               :". date('d-M-Y H:m:s',$mails_donnes['date_spam'])."<br />".		
"Il vous reste encore ". int_to_heure($mails_donnes['reste'])  . " avant le d&eacute;blocage par votre FAI<br />
  qui devrait avoir lieu le ".date('d-M-Y H:m:s',$mails_donnes['date_quarantaine'])."." ;
		
		}
			
	  	$erreur_message .=  '</pre>'.
	   	'
	  
	  '.
	"Dernier message re&ccedil;u.:<br />". $mails_donnes['message']. "<br /> ";
	  $ret = "break";
 }

  sauve_donnes();
 $ret=true;
 
 return $ret ;
 
}

//==========================================================================================
function admin_menu($menu)
{
    array_push($menu, array('NAME' => 'Mail_Superv',
      'URL' => get_admin_plugin_menu_link(MAIL_SUPERV_PATH . 'admin/mail_superv_admin.php')));
    return $menu;
}


add_event_handler('get_admin_plugin_menu_links', 'admin_menu');
//add_event_handler('loc_end_page_tail', 'affiche_message');
add_event_handler('loc_after_page_header', 'affiche_message');

?>
